/********************************************************            
************           generator.h  				 ************         
********************************************************/
#define FCY  10000000uL

#define USE_AND_OR
#define Delay_ms(d) (__delay32 (((d)) * ((FCY) / 1000uL)))
#define Delay_us(d) (__delay32 (((d)) * ((FCY) / 1000000uL)))        
                           
#define nop() {__asm__ volatile("nop");}// ( )

#define VKL 1
#define VIKL 0

#define MIST 85  //  

// pin      =FEDCBA9876543210=
#define MASK_STR 0b0011001111000000 //   c(ROW1...ROW6)

//
#define BUZ  LATAbits.LATA0

// 
#define COL1 PORTBbits.RB10
#define COL2 PORTAbits.RA4
#define COL3 PORTBbits.RB4
#define ROW1 LATBbits.LATB6
#define ROW2 LATBbits.LATB7
#define ROW3 LATBbits.LATB8
#define ROW4 LATBbits.LATB9
#define ROW5 LATBbits.LATB13
#define ROW6 LATBbits.LATB12

//   /
#define COL1_IN_OUT TRISBbits.TRISB10
#define COL2_IN_OUT TRISAbits.TRISA4
#define COL3_IN_OUT TRISBbits.TRISB4
#define ROW1_IN_OUT TRISBbits.TRISB6
#define ROW2_IN_OUT TRISBbits.TRISB7
#define ROW3_IN_OUT TRISBbits.TRISB8
#define ROW4_IN_OUT TRISBbits.TRISB9
#define ROW5_IN_OUT TRISBbits.TRISB13
#define ROW6_IN_OUT TRISBbits.TRISB12

#define IN 1
#define OUT 0

//./.  
#define COL1_CNPU CNPU2bits.CN16PUE
#define COL2_CNPU CNPU1bits.CN0PUE
#define COL3_CNPU CNPU1bits.CN1PUE
#define ROW1_CNPU CNPU2bits.CN24PUE
#define ROW2_CNPU CNPU1bits.CN23PUE
#define ROW3_CNPU CNPU1bits.CN22PUE
#define ROW4_CNPU CNPU1bits.CN21PUE
#define ROW5_CNPU CNPU1bits.CN13PUE
#define ROW6_CNPU CNPU1bits.CN14PUE

#define ON 1
#define OFF 0 

//     
#define NUM_ROW 6
#define NUM_COLUMN 3
		 	 
/***********************************                   
******** 				   *******                                                             
************************************/

unsigned char t;										// 
unsigned int T;											// 
unsigned char KEY;	 								//      UART	

//     
unsigned char mass_klav[NUM_ROW][NUM_COLUMN];//  = "0"   
																						 //  = "1",   
//  :
//:           SB1  SB2  SB3  SB4  SB5",SB6, SB7  SB8  SB9
char keycodes[18] = {0x01,0x02,0x03,0x04,0x05,0x06,0x07,0x08,0x09,  
//                   SB10 SB11 SB12 SB13,SB14 SB15 SB16 SB17 SB18										 
										 0x0A,0x0B,0x0C,0x0D,0x0E,0x0F,0x10,0x11,0x12
										};
								 
/***********************************                   
************** **************                                                            
************************************/

// 
void portinit64002(void); 				

//  IO
void pinmapconfig(void);

// UART
void UART1init(void);

//  
void init_module(void);						//  	

void CNconfig64002(void);					//  CN
void __attribute__((interrupt,no_auto_psv)) _CNInterrupt(void);
void scankeypad(void);						//   
																	//  
																																		
void init_module(void);           //  																	






